"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from pydantic import model_serializer
from skylight_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from typing_extensions import NotRequired, TypedDict


class FilesModelTypedDict(TypedDict):
    pass


class FilesModel(BaseModel):
    pass


class InstanceStatusResponseTypedDict(TypedDict):
    instance_id: str
    state: str
    r"""Current state of the instance"""
    timeout: int
    r"""Timeout in minutes before instance auto-termination"""
    used_minutes: int
    r"""Minutes used by the instance so far"""
    knowledge: str
    r"""Current knowledge of the instance"""
    livestream_url: str
    r"""URL to livestream the instance"""
    assigned_at: NotRequired[Nullable[str]]
    r"""When the instance was assigned"""
    files: NotRequired[Nullable[FilesModelTypedDict]]
    r"""Files on the instance organized by type (downloads, uploads)"""


class InstanceStatusResponse(BaseModel):
    instance_id: str

    state: str
    r"""Current state of the instance"""

    timeout: int
    r"""Timeout in minutes before instance auto-termination"""

    used_minutes: int
    r"""Minutes used by the instance so far"""

    knowledge: str
    r"""Current knowledge of the instance"""

    livestream_url: str
    r"""URL to livestream the instance"""

    assigned_at: OptionalNullable[str] = UNSET
    r"""When the instance was assigned"""

    files: OptionalNullable[FilesModel] = UNSET
    r"""Files on the instance organized by type (downloads, uploads)"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["assigned_at", "files"]
        nullable_fields = ["assigned_at", "files"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
